//
//ヘルパーのポート番号
const HELPER_AT = '8002';
//ヘルパーのURL
const HELPER_URL = 'http://localhost';

var tempreture = '';
var pressure = '';
var report_string = '';
var analogPins = [];
var digitalPins = [];

const BASEURL = HELPER_URL + ':' + HELPER_AT + '/';

(function(ext) {
    ext._shutdown = function() {};

    ext._getStatus = function() {
        return {status: 2, msg: 'Ready'};
    };

    //Polling
    setInterval( function() {
        $.ajax({
              url: BASEURL + 'poll',
              dataType: 'text',
        }).done( (data) => {
            retVals = data.split('\n');
            retVals.forEach(function(retdata){
              var tmp_str  = retdata.split(' ');
              //気温
              if(tmp_str[0] == 'tempreture'){
		tempreture = tmp_str[1];
              }  
              //気圧
              if(tmp_str[0] == 'pressure'){
		pressure = tmp_str[1];
              }  
              if(retdata.indexOf('analogValue/') !== -1){
		var pinvaldata = retdata.split('/');
		var tmp_pinval = pinvaldata[1].split(' ');
		analogPins[tmp_pinval[0]] = tmp_pinval[1];
              }
              if(retdata.indexOf('digitalValue/') !== -1){
		var pinvaldata = retdata.split('/');
		var tmp_pinval = pinvaldata[1].split(' ');
		digitalPins[tmp_pinval[0]] = tmp_pinval[1];
              }
            });
	});
    }, 100);

    ext.tempreture = function() {
        return tempreture;
    };

    ext.pressure = function() {
	return pressure;
    };

    ext.pinmode = function(pin, val) {
        var TARGET = BASEURL + 'pinmode/'  + pin + '/' + val;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.pinval = function(pin, val) {
        var TARGET = BASEURL + 'pinval/'  + pin + '/' + val;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.pinmodeD = function(pin, val) {
        var TARGET = BASEURL + 'pinmodeD/'  + pin + '/' + val;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.pinvalD = function(pin, val) {
        var TARGET = BASEURL + 'pinvalD/'  + pin + '/' + val;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.pinpwm = function(pin, val) {
        var TARGET = BASEURL + 'pinpwm/'  + pin + '/' + val;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.servoPin = function(pin, val) {
        var TARGET = BASEURL + 'servoPin/'  + pin + '/' + val;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.servoAngle = function(pin, val) {
        var TARGET = BASEURL + 'servoAngle/'  + pin + '/' + val;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.lcdinit = function() {
        var TARGET = BASEURL + 'lcdinit';
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.lcdbacklight = function(val) {
        var TARGET = BASEURL + 'lcdbacklight/'  + val;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.lcdmsg = function(dline, dspmsg) {
        var TARGET = BASEURL + 'lcdmsg/'  + dline + '/' + dspmsg;
        $.ajax({
              url: TARGET,
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    ext.analogValue = function(pin) {
        return analogPins[pin];
    };

    ext.digitalValue = function(pin) {
        return digitalPins[pin];
    };

    ext.gettemppress = function() {
        $.ajax({
              url: BASEURL + 'gettemppress',
              dataType: 'html',
	})
        return {status: 2, msg: 'Ready'};
    };

    // Block and block menu descriptions
    var descriptor = {
	blocks: [
		[" ", " %m.digitalPins ピンを %m.pinModes にする", "pinmode", "D2", "INPUT"],
		[" ", " %m.digitalPins ピンを %m.pinValues にする", "pinval", "D2", "Low"],
		[" ", " %m.pwmPins ピンに %n を出力する(PWM)", "pinpwm", "D3", "0"],
		["r", "デジタル %m.digitalPins の値", "digitalValue","D2"],
		["r", "アナログ  %m.analogPins の値", "analogValue", "A0"],
		[" ", "D %n ピンを %m.pinModes にする", "pinmodeD", "2", "INPUT"],
		[" ", "D %n ピンを %m.pinValues にする", "pinvalD", "2", "Low"],
		[" ", "D %n ピンに %n を出力する(PWM)", "pinpwmD", "3", "0"],
		[" ", "気温気圧を測定", "gettemppress"],
		['r', "気温", 'tempreture'],
		["r", "気圧", "pressure"],
		[" ", "サーボ %m.servonum を %m.digitalPins に接続する", "servoPin", "1", "D2"],
		[" ", "サーボ %m.servonum の角度を %n にする", "servoAngle", "1", "0"],
		[" ", "液晶を使う", "lcdinit"],
		[" ", "液晶バックライトを %m.lcdBackL", "lcdbacklight", "ON"],
		[" ", "液晶 %m.lcdLine 行目に %s を表示", "lcdmsg" , "1", " "],
	],
	menus: {
		"digitalPins": ["D2","D3","D4","D5","D6","D7","D8","D9","D10","D11","D12","D13"],
		"analogPins": ["A0","A1","A2","A3","A4","A5"],
		"pwmPins": ["D3","D5","D6","D10","D11"],
		"pinValues": ["Low", "High"],
		"pinModes": ["INPUT", "OUTPUT"],
		"servonum": ["1", "2"],
		"lcdBackL": ["ON", "OFF"],
		"lcdLine": ["1", "2"],
	},
    };

    ScratchExtensions.register('Arduino', descriptor, ext);
})({});
